#include "Interviewee.h"
#include "TheSettingsSingleton.h"
#include <qstring.h>

static const char* theNameBase = "/name";
static const char* theCompBase = "/company";
static const char* theCounBase = "/country";
static const char* theGendBase = "/gender";

Interviewee::Interviewee(const QString& aBase, unsigned int aNumber) 
	: NumberedList<Entry>(aBase + QString::number(aNumber)) 
{
	theName = TheSettingsSingleton::getQSRef().readEntry(theBase + theNameBase, "");
	DEBUG5("Interviewee::theName = %s\n", theName.ascii());
	theCompany = TheSettingsSingleton::getQSRef().readEntry(theBase + theCompBase, "");
	theCountry = TheSettingsSingleton::getQSRef().readEntry(theBase + theCounBase, "");
	theGender = TheSettingsSingleton::getQSRef().readEntry(theBase + theGendBase, "");
}

Interviewee::~Interviewee()
{
}

bool Interviewee::save()
{
	DEBUG5("Interviewee('%s')::save\n", theName.ascii());
	TheSettingsSingleton::getQSRef().writeEntry(theBase + theNameBase, theName);
	TheSettingsSingleton::getQSRef().writeEntry(theBase + theCompBase, theCompany);
	TheSettingsSingleton::getQSRef().writeEntry(theBase + theCounBase, theCountry);
	TheSettingsSingleton::getQSRef().writeEntry(theBase + theGendBase, theGender);
	NumberedList<Entry>::save();
}

