#ifndef INTERVIEWEE_H_
#define INTERVIEWEE_H_

#include "Entry.h"
#include "NumberedList.h"

class Interviewee : public NumberedList<Entry>
{
public:
	
	Interviewee(void) : NumberedList<Entry>("/lala") {};
	Interviewee(const QString& aBase, unsigned int aNumber);
	virtual ~Interviewee();
	
	virtual bool save(void);
	
	Entry* newEntry(int aNumber, const QString& anAnswer)
	{	
		assert(aNumber != 0);
		return new Entry(theBase, aNumber, anAnswer);
	};

	const QString& text() const
	{ return theName; };
	
	void setText(const QString& aText)
	{ theName = aText; };
	
public:
	QString theName;
	QString theCompany;
	QString theGender;
	QString theCountry;
};

#endif /*INTERVIEWEE_H_*/
