#ifndef NUMBEREDLIST_H_
#define NUMBEREDLIST_H_

#include "questionaire_global.h"
#include <qstring.h>
#include <qvaluelist.h>

template<class NumberedListItem>
class NumberedList
{
public:
	NumberedList(const QString& aBase) : theBase(aBase)
	{
		DEBUG5("NumberedList(\"%s\")\n", aBase.ascii());
		int i;
		for (i=1; i<100; i++)
		{
			NumberedListItem myNewEntry(theBase, i);
			if (myNewEntry.text().isEmpty())
				break;
			// push_back will make a copy
			theList.push_back(myNewEntry);
		}
	};

	
	virtual ~NumberedList() {};
	
	virtual bool save()
	{
		QValueListIterator<NumberedListItem> i;
		for(i = theList.begin(); i!=theList.end();i++)
			(*i).save();
		return true;
	}
	
	virtual const NumberedListItem& operator[](unsigned int i) const
	{
		return theList[i-1];
	};
	
	virtual void push_back(const NumberedListItem& anItem)
	{
		theList.push_back(anItem);
	}
	
	typedef QValueListIterator<NumberedListItem> iterator;
	typedef QValueListConstIterator<NumberedListItem> const_iterator;
	iterator begin(void) {return theList.begin();};
	const_iterator begin(void) const {return theList.begin();};
	iterator end(void) {return theList.end();};
	const_iterator end(void) const	{return theList.end();};
	
	unsigned int size(void)
	{ return theList.size(); };
	
protected:
	unsigned int	theHighestFound;
	QString			theBase;

	typedef QValueList<NumberedListItem> NumListType;
	NumListType	theList;
};

#endif /*NUMBEREDLIST_H_*/
