/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <qlabel.h>
#include <qcombobox.h>
#include <map>

using namespace std;

QString num2digits(int aNumber, int aDigitCount)
{
	QString myNum = "00000000000000" + QString::number(aNumber);
	return myNum.right(aDigitCount);
}


void printline(int aQnr, int aAnr, const char* aString, int aCount, int aTotal)
{
	static FILE* theoutput = NULL;
	if (theoutput==NULL)
		theoutput=fopen("results,txt","w");
	
	if (aCount == 0)
		fprintf(theoutput, "%2d\t\t%s\t\t\n",
			aQnr, aString);
	else
		fprintf(theoutput, "\t%2d\t%s\t%2d\t%2d\n",
			aAnr, aString, aCount, (100*aCount)/aTotal);
}

void MainWindow::init()
{
	QuestionList::const_iterator i;
	int myNumberOfQuestions = theQuestions.size();
	theAnswers.push_back(new Answers(0, theInterviewees));
	for (int i=1; i<=myNumberOfQuestions; i++ )
	{
		theAnswers.push_back(new Answers(i, theInterviewees));
	}

	printf("\n****\n****  SUMMARY \n****\n");
	for (int i=1; i<=myNumberOfQuestions; i++ )
	{
		QListViewItem* myQuestionPtr = 
			new QListViewItem(theAnswersView, 
					QString("%1 %2")
						.arg(num2digits(i,2))
						.arg(theQuestions[i].text()), "");
		printline(i, 0, theQuestions[i].text().ascii(), 0, 0);
		int myTotalAnswerCount = 0;

		// first, we need to retrieve all info 
		// and store it in "mySorted"
		typedef multimap<int, QString> SortedAnswers;
		typedef pair<int, QString> Pair;
		SortedAnswers mySorted;
		QString myAnswer = theAnswers[i]->getFirstS();
		int myAnswerCount= theAnswers[i]->getFirstI();
		for (int j=1;; j++)
		{
			if (myAnswer.isEmpty())
				break;
			if (myAnswer != "---")
			{
				mySorted.insert(Pair(myAnswerCount, myAnswer));
				QListViewItem* myAnswerPtr = 
					new QListViewItem(myQuestionPtr, 
							"   " + myAnswer, QString::number(myAnswerCount));
				myTotalAnswerCount += myAnswerCount;
			}			
			myAnswer = theAnswers[i]->getNextS();
			myAnswerCount = theAnswers[i]->getNextI();
		}
		// then we retrieve the info from it (auto sorted)
		SortedAnswers::iterator myI = mySorted.begin();
		int myCount = mySorted.size()+1;
		for (; myI != mySorted.end(); ++myI)
		{
			myCount--;
			// don't write the "unique" entries
//			if ((*myI).first==1)
//				continue;
			printline( 0, myCount, (*myI).second.ascii(), (*myI).first, myTotalAnswerCount); 
		}
		
		
		myQuestionPtr->setText(1, "  " + num2digits(myTotalAnswerCount,2));
	}
	theAnswersView->setTreeStepSize(40);
	
	theHLayouts.push_back(new QHBoxLayout(0,0,6,"dummy"));
	theLabels.push_back(new QLabel(NULL, "dummylab"));
	theCombos.push_back(new QComboBox(NULL, "dummycombo"));
	theLEdits.push_back(new QLineEdit(NULL, "dummyedit"));
	
	printf("\n****fill comboboxes****\n");
	for (int i=1; i<=myNumberOfQuestions; i++ )
	{
		QString myI = QString::number(i);
		theHLayouts.push_back(new QHBoxLayout(0,0,6, "layout"));
		theLabels.push_back(new QLabel(QuestionsBox, "theLabels"+myI));
		theLabels[i]->setText(theQuestions[i].text());
		theHLayouts[i]->addWidget(theLabels[i]);
		
		theCombos.push_back(new QComboBox( FALSE, QuestionsBox, 
				"theComboBox"+myI));
		theCombos[i]->insertItem("");
		theCombos[i]->insertItem("---");
		theCombos[i]->setMaximumWidth(200);
		QString myAnswer = theAnswers[i]->getFirstS();
		for (int j=1;; j++)
		{
			 if (myAnswer.isEmpty())
				 break;
			 if (myAnswer!="---")
				 theCombos[i]->insertItem(myAnswer);
			 myAnswer = theAnswers[i]->getNextS();
		}
		theHLayouts[i]->addWidget(theCombos[i]);
	
		theLEdits.push_back(new QLineEdit(QuestionsBox, "theLineEdit"+myI));
		theHLayouts[i]->addWidget(theLEdits[i]);
		QuestionsBoxLayout->addLayout(theHLayouts[i]);
	}
	
	printf("\n****fill intervieweelist****\n");
	theListViewInterviewees->clear();
	IntervieweeList::const_iterator j;
	int k=1;
	for (j=theInterviewees.begin(); j!=theInterviewees.end(); ++j)
	{
		QListViewItem* myBigIgnoredPtr = new QListViewItem(theListViewInterviewees,
				num2digits(k,3),
				(*j).theName, (*j).theCompany, (*j).theCountry, (*j).theGender );
		k++;
	}
	
	
}


void MainWindow::save()
{
	if (!check())
	{
		Popup::Info("You did not fill in everything yet!", this);
		return;
	}
	Interviewee* myNewInterviewee = theInterviewees.getNewInterviewee();
	myNewInterviewee->theCountry = theCountry->text();
	myNewInterviewee->theCompany = theCompany->text();
	myNewInterviewee->theGender  = theGenderBox->currentText();
	myNewInterviewee->theName    = theIntervieweeName->text();
	
	
	// and add the questions
	for (unsigned int i=1; i<=theQuestions.size();i++)
	{
		QString myAnswer = theCombos[i]->currentText();
		if (myAnswer.isEmpty())
		{
			myAnswer = theLEdits[i]->text();
		}
		assert(myAnswer.isEmpty()==false);
		Entry* myEntryPtr = myNewInterviewee->newEntry(i, myAnswer);
		myNewInterviewee->push_back(*myEntryPtr);
		delete myEntryPtr;
	}

	myNewInterviewee->save();
	Popup::Info("Info saved", this);
	exit(0);
}

bool MainWindow::check()
{
	bool myReturn = true;
	// check if all one-time parameters have been filled out
	if (theCompany->text().isEmpty())
	{
		theCompanyLabel->setPaletteForegroundColor(QColor("red"));
		myReturn=false;
	}
	if (theCountry->text().isEmpty())
	{
		theCountryLabel->setPaletteForegroundColor(QColor("red"));
		myReturn=false;
	}
	if (theIntervieweeName->text().isEmpty())
	{
		theIntervieweeNameLabel->setPaletteForegroundColor(QColor("red"));
		myReturn=false;
	}
	
	// check if all questions are filled-in
	for (unsigned int i=1; i<=theQuestions.size();i++)
	{
		if (theCombos[i]->currentText().isEmpty())
			if (theLEdits[i]->text().isEmpty())
			{
				theLabels[i]->setPaletteForegroundColor(QColor("red"));
				myReturn=false;
			}
	}
	return myReturn;
}

void MainWindow::clear()
{
	theCountry->setText("");
	theCompany->setText("");
	theIntervieweeName->setText("");

	theCompanyLabel->setPaletteForegroundColor(QColor("black"));
	theCountryLabel->setPaletteForegroundColor(QColor("black"));
	theIntervieweeNameLabel->setPaletteForegroundColor(QColor("black"));
	
	// and add the questions
	for (unsigned int i=1; i<=theQuestions.size();i++)
	{
		theLabels[i]->setPaletteForegroundColor(QColor("black"));
		theCombos[i]->setCurrentItem(0);
		theLEdits[i]->setText("");
	}
}
